[push]
  default = simple
[commit]
  gpgsign = true
[alias]
  # Commitizen
  cz = cz-customizable
  # Commands that should exist
  stage = add
  unstage = reset HEAD --
  unadd = unstage
  uncommit = reset --soft HEAD~1
  unstash = stash pop
  orphan = checkout --orphan
  merges = log --merges
  new = !git checkout -b && git push -u origin $1 && true
  # Utilities
  aliases = !git config --list | grep 'alias\\.' | sed 's/alias\\.\\([^=]*\\)=\\(.*\\)/\\1\\ \t => \\2/' | sort
	which = !git aliases | grep "^$1 " || git aliases | grep --color "$1" || echo "not found: "
	export = archive -o latest.tar.gz -9 --prefix=latest/
	trim = !git reflog expire --expire=now --all && git gc --prune=now
  # Informational
  last = "!{ git log -1 --color; echo; git diff HEAD^ --color;  } | less"
	recent = log --oneline -5
	where = !git branch | grep '^*' | awk '{ print $2 }'
  default=!git remote show origin | grep HEAD | cut -d':' -f2 | tr -d '[:space:]'
	hash = rev-parse --short HEAD
  # Mangrove
  mfile=config --file .gitroots
  mlist=mfile --get-all list.root
  mlink=!git mfile hash.$1 || (git mfile hash.$1 $2 && git mfile --add list.root $1) && true
  mpath=!git mfile hash.$1 && true
  mjoin=!git remote add $1 $2 && git fetch $1 && git merge "$1/$(git default)" --allow-unrelated-histories -X theirs && git mlink $1 $2 && true
  msync=!git fetch $1 && git merge "$1/$(git default)" -X theirs && true
  minit="!for r in $(git mlist); do git remote get-url $r || git mjoin $r $(git mpath $r); done; true"
  # Tiny commands
  a = add
  aa = add .
  b = branch
  bs = branch -av
  bd = branch -D
  bdr = !git push origin :$1 && true
  bda = !git bd $1 && git bdr $1 && true
  c = commit
  d = diff
  fr = !git fetch && git rebase,
  g = log --graph --pretty=format:'%Cred%h%Creset -%C(yellow)%d (%Cgreen%cr %C(bold blue)by %an%C(yellow))%Creset %s' --abbrev-commit --date=relative
  h = hash
  i = init
  l = log --use-mailmap --decorate=short --oneline
  ld = log -n1 -p --format=fuller
  ll = log --pretty='%n %C(yellow)%h %C(black)| %Cgreen%<(14)%ar %C(black)| (%G?) %Cblue%<(14,trunc)%aN%Cred%d%n %C(cyan)%<(60,trunc)%s%Creset'
  lla = log --use-mailmap --show-signature --decorate=full --pretty=full
  m = merge
  n = new
  o = checkout
  p = push
  q = push -u
  r = rebase
  s = status -s
  ss = status
  t = tag
  ta = !git tag $1 && git push --tags && true
  td = tag --delete
  tdr = push --delete origin
  tda = !git td $1 && git tdr $1 && true
  tm = !git tda && git ta $1 && true
  u = uncommit
  w = which
